<?php
/*----------------------------------------------------------------------------------+
| COMBRIX - Content Management System
| Version 1.x
+-----------------------------------------------------------------------------------+
| Copyright © 2009-2010 MK-WebSoft
| http://www.combrix.de/
+-----------------------------------------------------------------------------------+
| This program is released as open source software under
| MK-WebSoft license. http://www.combrix.de/license.pdf
| Removal of this copyright header is strictly prohibited
| without written permission from the original author(s).
+-----------------------------------------------------------------------------------+
| Themename: red-passion
| Version: v3-01-2011
| Theme-Lizenz: AGPL3
| Theme-Copyright: Christian Blenk
| created on: 03-01-2011 (mm/dd/yyyy)
| modified on: 03-01-2011 (mm/dd/yyyy)
+-----------------------------------------------------------------------------------*/
require_once "../../../maincore.php";
define("STYLE_DIR", THEME."images/progress_bar/");

$style	= $_REQUEST['style'];
$width	= $_REQUEST['width'];
$done	= $_REQUEST['done'];
$total	= $_REQUEST['max'];
$warning = $_REQUEST['warn'];

$exceet   = $done/$total;

if (!is_numeric($total))	error('504 Service Unavailable', 'max parameter incorrect');
if (!is_numeric($done))		error('505 Service Unavailable', 'done parameter incorrect');
if (!is_numeric($width))	error('506 Service Unavailable', 'width parameter incorrect');
if (!is_numeric($warning))	error('507 Service Unavailable', 'warning parameter incorrect');

	$bg       = @imagecreatefrompng(STYLE_DIR . $style . '-bg.png');
	$fill     = @imagecreatefrompng(STYLE_DIR . $style . '-fill.png');
	$fill_red = @imagecreatefrompng(STYLE_DIR . $style . '-fill_red.png');
	$bg_cap   = @imagecreatefrompng(STYLE_DIR . $style . '-bg-cap.png');
	$fill_cap = @imagecreatefrompng(STYLE_DIR . $style . '-fill-cap.png');
	$fill_cap_red = @imagecreatefrompng(STYLE_DIR . $style . '-fill-cap_red.png');
	
	if(!$bg || !$fill || !$bg_cap || !$fill_cap) {
		error('503 Service Unavailable', 'Error reading fragments');
	}
	
	$fill_width = round((($width - imagesx($bg_cap)) * $done) / $total) - imagesx($fill_cap);
	$image = imagecreatetruecolor($width, imagesy($bg));
	imagecopy($image, $bg, 0, 0, 0, 0, imagesx($bg), $width - imagesx($bg_cap));
	imagecopy($image, $bg_cap, $width - imagesx($bg_cap), 0, 0, 0, imagesx($bg_cap), imagesy($bg_cap));
	if($exceet >= $warning){imagecopy($image, $fill_red, 0, 0, 0, 0, $fill_width, imagesy($fill_red));}
	else{imagecopy($image, $fill, 0, 0, 0, 0, $fill_width, imagesy($fill));}
	if($exceet >= $warning){imagecopy($image, $fill_cap_red, $fill_width, 0, 0, 0, imagesx($fill_cap_red), imagesy($fill_cap_red));}
	else {imagecopy($image, $fill_cap, $fill_width, 0, 0, 0, imagesx($fill_cap), imagesy($fill_cap));}
	header("Content-Type: image/png");
	imagepng($image);
	imagedestroy($bg);
	imagedestroy($fill);
	imagedestroy($fill_red);
	imagedestroy($bg_cap);
	imagedestroy($fill_cap);
	imagedestroy($fill_cap_red);
	imagedestroy($image);


	function error($code, $desc) {
		header($_SERVER['SERVER_PROTOCOL'] . ' ' . $code);
		if(strtoupper($_SERVER['REQUEST_METHOD']) != 'HEAD') {
			echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
			echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n";
			echo '<html xml:lang="en" lang="en">';
			echo '<head><title>' . $code . '</title></head><body><h1>' . $code . '</h1><p>' . $desc . '</p></body></html>';
		}
		exit;
	}
?>
