<?php
/*----------------------------------------------------------------------------------+
| COMBRIX - Content Management System
| Version 1.x
+-----------------------------------------------------------------------------------+
| Copyright  2009-2010 MK-WebSoft
| http://www.combrix.de/
+-----------------------------------------------------------------------------------+
| This program is released as open source software under
| MK-WebSoft license. http://www.combrix.de/license.pdf
| Removal of this copyright header is strictly prohibited
| without written permission from the original author(s).
+-----------------------------------------------------------------------------------+
| Themename: red-passion
| Version: v1-11-2010
| Theme-Lizenz: AGPL3
| Theme-Copyright: Christian Blenk
| created on: 03-01-2011 (mm/dd/yyyy)
| modified on: 03-01-2011 (mm/dd/yyyy)
+-----------------------------------------------------------------------------------*/

if (!defined("IN_FUSION")) { header("Location: ../../index.php"); exit; }
// theme settings

define("DOCTYPE","html");

$toplogin = true; // Set to "false" if no header login is needed - set "true" to switch on
$loadscreen = true;  // Set to "false" if no loading screen is required - set "true" to switch on
$twittername = ""; //Set your twitter account name here and the bird will be displayed.
$progressbar_style = "led"; // possible Styles are cm, winxp, solaris, led and osx. Try your own Style
$pm_warning = 0.85; // set from 0.0-1.0 || To disabeled warning set to 1.0  0.85 means 85% of max. available PM's

$body_text = "#cccccc";
$body_bg = "#000000";
$theme_width_l = "160px";
$theme_width_r = "160px";

$wztool['border_width'] = '1';
$wztool['border_color'] = '#FF0000';
$wztool['bgcolor'] = '#000'; // #FFFFFF
$wztool['width'] = '0';
$wztool['title_padding'] = '2';
$wztool['padding'] = '2';
$wztool['fcolor'] = '#ccc';

// Benutzerfarben fr die colorize_user() Funktion
// $user_colors=array(SUPERADMIN Farbe,ADMIN Farbe,GLOBALMOD Farbe,MOD Farbe);
$user_colors=array("#D10000","#FF8500","#9A9AFF","#54A454");

// Email-Picture
// text color
$etext_color = array('223','224','225'); // RGB Colors
// background color
$ebg_color = array('0','0','0');		// RGB Colors

define("LEFT_PANEL_START",'<td class="side-border-left" valign="top"><div class="image-left"><img src="'.THEME.'images/blank.gif" style="width:'.$theme_width_l.';height:0px;border:0px" alt=""></div>');
define("LEFT_PANEL_END",'</td>');
define("CONTENT_START",'<td class="main-bg" width="100%" valign="top">');
define("CONTENT_END","</td>");
define("RIGHT_PANEL_START",'<td class="side-border-right" valign="top"><div class="image-right"><img src="'.THEME.'images/blank.gif" style="width:'.$theme_width_r.';height:0px;border:0px" alt=""></div>');
define("RIGHT_PANEL_END","</td>");

function theme_layout() {
	require_once('layout.html.php');
}

function stripchar($ord) {
$boxname="";
for ($i=0; $i<strlen($ord);$i++) {
if (($ord[$i] >="A" and $ord[$i] <= "Z") or ($ord[$i] >="a" and $ord[$i] <= "z") ) {
$boxname=$boxname.$ord[$i];
}
}
return $boxname;
}

function loadscreenstart() {
	echo"<center>
	<div id='SiteOverlay' style='z-index: 50; opacity: 0.8; position: absolute; width: 100%; height: 5000px; top: 0px; left: 0px; background-color: #000000; display: inline;'>
	<div id='SiteOverlayMessage' style='position: absolute; top: 300px; left: 50%; margin:-50px 0 0 -50px; height:30px;'><img src='".THEME."images/loading.gif' alt='page is loading'></div>
	</div>
	</center>
	<script type='text/javascript'>
	
	$(document).ready(function () 
	{
        var img = new Image();
        $(img).load(function () {
            $(this).hide();
            $('#loader').removeClass('loading').append(this);
            $(this).fadeIn();
        }).error(function () {
            // notify the user that the image could not be loaded
        }).attr('src', '');
	});

	function SiteTranslate(lang){
	$('body').translate(lang, {
	async: false, 
	toggle: false,
	data: true,
	returnAll: true
	});
	}
	</script>";
}

function loadscreenend(){
	echo"<script type='text/javascript'>
	$(document).ready(function () 
	{
		$('#SiteOverlay').fadeOut('slow');
	})
	</script>";
}

function progress_bar($style, $width, $done, $max, $symbol){
	global $locale, $lang, $pm_warning;

	$URI = THEME."includes/progress_bar.inc.php?style=%s&amp;width=%s&amp;done=%s&amp;max=%s&amp;warn=%s";
	$decimals = 0; $styles = array("winxp", "osx", "led", "solaris", "cm");
	
	if (($width < 64) || ($width > 1280)) $width = 100;
	if ($max < 1) $max = 100;
	if ($done < 0) $done = 0;
	if ($done > $max) $max = $done;
	if(!in_array($style, $styles)) $style = "osx";
	if ($symbol == "%"){
		$displayValue = $done/$max*100;
		$displayValue = number_format($displayValue, $decimals, '.', '');
	}
	$content = "<img src='".sprintf($URI, $style, $width, $done, $max, $pm_warning)."' title='".sprintf($lang['LOGINBOX_023'], $done, $max)."' alt='".sprintf($lang['LOGINBOX_023'], $done, $max)."'>";
	$content .= "<div style='display:inline;margin-left:4px;position:relative;bottom:2px;'>".$displayValue.$symbol."</div>";
	return $content;
}

function loginbox() {
	global $locale, $userdata, $aidlink, $settings, $progressbar_style;
	
	if(is_file(THEME."locale/".LANGUAGE.".php")) {
		require_once THEME."locale/".LANGUAGE.".php";
	} else {
		require_once THEME."locale/English.php";
	}

	
	if(!iMEMBER) {
		$loginbox = "<form name='loginformtop' method='post' action='".PHP_SELF.(FUSION_QUERY ? "?".FUSION_QUERY : "")."'>\n";
		$loginbox .= "<table id='navi-bg' class='loginbox l-login'>\n";
		$loginbox .= "<tr>\n";
		$loginbox .= "<td valign='top' align='right'>";
		if ((bool)$settings['enable_registration'] && (bool)USER_REGISTER)
 			{$loginbox .= "<a href='register.php' target='_self'><img src='".THEME."images/register.png' style='padding-right:4px; float:left;' alt='".$lang['LOGINBOX_024']."' title='".$lang['LOGINBOX_024']."'></a>";	}
		$loginbox .= "<input id='name' type='text' name='user_name' class='textbox' tabindex='1' value='".$locale['061']."' onClick='this.value=\"\"'></td>\n";
		$loginbox .= "</tr>\n<tr>\n";
		$loginbox .= "<td style='height:10px'></td></tr>";
		$loginbox .= "<tr><td valign='top' align='right'><a href='lostpassword.php' target='_self'><img src='".THEME."images/lostpass.png'  style='padding-right:4px; float:left;' alt='".$lang['LOGINBOX_025']."' title='".$lang['LOGINBOX_025']."'></a><input id='pw' type='password' name='user_pass' class='textbox' value='".$locale['062']."' onClick='this.value=\"\"' tabindex='2'></td>\n";
		$loginbox .= "</tr>\n<tr>\n";
		$loginbox .= "<td valign='top' align='right'><span>".$lang['LOGINBOX_026']."</span> <input type='checkbox' name='remember_me' value='y' title='".$locale['063']."' style='vertical-align:top;'>&nbsp;<input type='submit' class='button' name='login' value='".$locale['060']."' tabindex='3'></td>\n";
		$loginbox .= "</tr>\n<tr>\n";
		$loginbox .= "<td valign='top' align='right'>".(isset($loginerror) ? $loginerror : "")."</td>\n";
		$loginbox .= "</tr>\n</table>\n</form>\n";
	} else {
		$img_path 	= THEME."images/";
		$data		= dbarray(dbquery("SELECT * FROM ".DB_PREFIX."messages_options WHERE user_id='0'"));
		$inbox_count	= dbcount("(message_id)", messages, "message_to = '".$userdata['user_id']."' AND message_folder = '0'");
		$outbox_count	= dbcount("(message_id)", messages, "message_to = '".$userdata['user_id']."' AND message_folder = '1'");
		$archive_count	= dbcount("(message_id)", messages, "message_to = '".$userdata['user_id']."' AND message_folder = '2'");	
		$msg_count	= dbcount("(message_id)", messages, "message_to = '".$userdata['user_id']."' AND message_read = '0' AND message_folder = '0'");
		
				$loginbox = "<table class='loginbox_main'>\n<tr>\n";
				$loginbox .= "<td align='left'>\n";
				$loginbox .= "<table cellspacing='0' cellpadding='5' align='center'>\n<tr>\n";
				$loginbox .= "<td><a href='".BASEDIR."messages.php?folder=inbox' style='text-decoration:none' title='".$lang['LOGINBOX_002']."'><img src='".$img_path."pn_inbox.png' style='vertical-align:top; padding-right:6px;'>";
				$loginbox .= "</a>".progress_bar($progressbar_style, round($width/3.5), $inbox_count, $data['pm_inbox'], '%');
				$loginbox .= "</td>\n";
				$loginbox .= "</tr>\n<tr>\n";
				$loginbox .= "<td><a href='".BASEDIR."messages.php?folder=outbox' style='text-decoration:none' title='".$lang['LOGINBOX_003']."'><img src='".$img_path."pn_outbox.png' style='vertical-align:top; padding-right:6px;'>";
				$loginbox .= "</a>".progress_bar($progressbar_style, round($width/3.5), $outbox_count, $data['pm_sentbox'], '%');
				$loginbox .= "</td>\n";
				$loginbox .= "</tr>\n<tr>\n";
				$loginbox .= "<td><a href='".BASEDIR."messages.php?folder=archive' style='text-decoration:none' title='".$lang['LOGINBOX_004']."'><img src='".$img_path."pn_archive.png' style='vertical-align:top; padding-right:6px;'>";
				$loginbox .= "</a>".progress_bar($progressbar_style, round($width/3.5), $archive_count, $data['pm_savebox'], '%');
				$loginbox .= "</td>\n";
				$loginbox .= "</tr>\n</table>\n";
				$loginbox .= "</td>\n";
				$loginbox .= "<td align='left' style='line-height:1.5'>\n";
				$loginbox .= "<img src=".THEME."/images/bullet.gif>&nbsp;<a href='".BASEDIR."edit_profile.php'>".$lang['LOGINBOX_005']."</a><br>\n";
				$loginbox .= "<img src=".THEME."/images/bullet.gif>&nbsp;<a href='".BASEDIR."search.php'>".$lang['LOGINBOX_006']."</a><br>\n";
				$loginbox .= "<img src=".THEME."/images/bullet.gif>&nbsp;<a href='".BASEDIR."faq.php'>".$lang['LOGINBOX_007']."</a><br>\n";
				$loginbox .= "<img src=".THEME."/images/bullet.gif>&nbsp;<a href='".BASEDIR."members.php'>".$lang['LOGINBOX_008']."</a><br>\n";
				$loginbox .= "<img src=".THEME."/images/bullet.gif>&nbsp;<a href='".BASEDIR."setuser.php?logout=yes'>".$lang['LOGINBOX_009']."</a><br>\n";
				$loginbox .= "</td>\n";
				$loginbox .= "</tr>\n";

				if(iADMIN && (iUSER_RIGHTS != "" || iUSER_RIGHTS != "C") && !$msg_count) {					
					$loginbox .= "<tr>\n<td colspan='2'>\n";
					$loginbox .= "<table width='100%' cellpadding='0' cellspacing='0' style='margin-top:2px;'>\n<tr>\n";
					$loginbox .= "<td align='center'><a href='".ADMIN_INDEX."&amp;pagenum=1#page1' title='".$lang['LOGINBOX_010']."'><img src='".$img_path."admin_content.png' alt='".$lang['LOGINBOX_010']."'></a></td>\n";
					$loginbox .= "<td align='center'><a href='".ADMIN_INDEX."&amp;pagenum=2#page2' title='".$lang['LOGINBOX_011']."'><img src='".$img_path."admin_user.png' alt='".$lang['LOGINBOX_011']."'></a></td>\n";
					$loginbox .= "<td align='center'><a href='".ADMIN_INDEX."&amp;pagenum=3#page3' title='".$lang['LOGINBOX_012']."'><img src='".$img_path."admin_main.png' alt='".$lang['LOGINBOX_012']."'></a></td>\n";
					$loginbox .= "<td align='center'><a href='".ADMIN_INDEX."&amp;pagenum=4#page4' title='".$lang['LOGINBOX_013']."'><img src='".$img_path."admin_infusion.png' alt='".$lang['LOGINBOX_013']."'></a></td>\n";
					$loginbox .= "</tr>\n</table>\n";
					$loginbox .= "</td>\n</tr>\n";
				}

				if($msg_count) {
					$loginbox .= "<tr>\n";
					$loginbox .= "<td colspan='2'><div align='center' class='small'><blink><b><a href='".BASEDIR."messages.php' style='color:#FF0000'>".sprintf($locale['085'], $msg_count).($msg_count == 1 ? $locale['086'] : $locale['087'])."</a></b></blink></div></td>\n";
					$loginbox .= "</tr>\n";
				}
				$loginbox .= "</table>";
	

	}

	return $loginbox;
}

function opentable($title) {
echo "<table width='100%' class='border'>
<tr><td class='capmain'>".$title."</td></tr>
<tr><td class='main-body'>\n";
}

function closetable() {
echo "</td>
</tr>
</table>\n";
}

function openside($title) {	
echo "<div style='width:100%' class='border'>
<div><table width='100%' cellspacing='0' cellpadding='0'>
  <tr><td class='l-scapmain'><img src='".THEME."images/blank.gif' style='width:15px;display:block;' alt='blank.gif'></td>
      <td class='scapmain'><div class='scapmain-t'>".$title."</div></td>
      <td class='r-scapmain'><img src='".THEME."images/blank.gif' style='width:10px;display:block;' alt='blank.gif'></td>
  </tr>
  </table>
</div>
<div class='side-body'>\n";
}

function closeside() {
echo "</div>
</div>\n";
tablebreak();
}

function openlabel($title,$state="on") {
global $tpl;
$boxname=stripchar($title);
$tpl->more_css('<style>#box_'.$boxname.' {'.($state=="on" ? '' : 'display:none;').'}</style>','text');
$tpl->more_javascript('
<script>
$(document).ready(function(){
$("#'.$boxname.'").click(function() {
	$("#box_'.$boxname.'").slideToggle();
	});
});
</script>
','text');	

echo "<div>
<div id='".$boxname."' style='cursor:pointer;' />
<table width='100%' cellspacing='1' cellpadding='1' class='side-label'><tr><td><img src='".THEMEIMAGE."bullet.gif' alt='' /> ".$title."</td></tr></table></div>
<div id='box_".$boxname."' />\n";
}

function closelabel() {
echo "</div>
</div>\n";
}

function opensidex($title,$state="on") {
global $tpl;
$boxname=stripchar($title);
$tpl->more_css('<style>#box_'.$boxname.' {'.($state=="on" ? '' : 'display:none;').'}</style>','text');
$tpl->more_javascript('
<script>
$(document).ready(function(){
$("#'.$boxname.'").click(function() {
	$("#box_'.$boxname.'").slideToggle();
	});
});
</script>
','text');	

echo "<div style='width:100%' class='border'>
<div id='".$boxname."' style='cursor:pointer;'>
  <table width='100%' cellspacing='0'>
    <tr><td class='l-scapmain'><img src='".THEME."images/blank.gif' style='width:15px;display:block;' alt='blank.gif'></td>
    <td class='scapmain' style='padding-right:5px;'>".panelbutton_div($state,$boxname)."</td>
    <td class='scapmain'><div class='scapmain-t'>".$title."</div></td>
    <td class='r-scapmain'><img src='".THEME."images/blank.gif' style='width:10px;display:block;' alt='blank.gif'></td>
    </tr>
  </table>
</div>
<div class='side-body' id='box_".$boxname."'".($state=="off" ? " style='display:none'" :"").">\n";
}

function closesidex() {
echo "</div>
</div>\n";
tablebreak();
}

function opentablex($title,$state="on") {
$boxname=stripchar($title);
echo "<div style='width:100%' class='border'>
<div onclick=\"javascript:flipBox('$boxname')\" style='cursor:pointer;'><table width='100%' cellspacing='1' cellpadding='1' class='scapmain'><tr><td width='1%'>".panelbutton_div($state,$boxname)."</td><td>".$title."</td></tr></table></div>
<div class='side-body' id='box_".$boxname."'".($state=="off" ? " style='display:none'" :"")." >\n";
}

function closetablex() {
echo "</div>
</div>\n";
tablebreak();
}

function tablebreak() {
echo "<div style='width:100%; height:10px;'>\n</div>\n";
}
?>